# Copyright (c) 2020 Watsen Networks.  All Rights Reserved.

import sys,argparse
from .  import __version__,sztpd
def main(argv=None):A=argparse.ArgumentParser(prog='sztpd',formatter_class=argparse.RawDescriptionHelpFormatter,description='SZTPD implements the "bootstrap server" defined in RFC 8572.',epilog='\nExit status code: 0 on success, non-0 on error.  Error output goes to stderr.\n\nThe "cacert" argument is a filepath to a PEM file that contains one or more X.509\ncertificates.  The list of certificates must be ordered from the certificate of\nthe issuer to the database\'s certificate to the self-signed root certificate.\n\nThe "key" argument is a filepath to a PEM file that contains a PKCS#12, encoding\nboth its private key and end-entity certificate.\n\nThe "database-url" argument has the form "<dialect>:<dialect-specific-path>".\nThree dialects are supported: "sqlite", "postgresql", and "mysql+pymysql".\nThe dialect-specific-path for each of these is described below.\n\nFor the "sqlite" dialect, dialect-specific-path follows the format "///<sqlite-path>",\nwhere sqlite-path can be one of:\n\n  :memory:    - an in-memory database (only useful for testing)\n  <filepath>  - an OS-specific filepath to a persisted database file\n\n  Examples:\n\n    $ sztpd sqlite:///:memory:                      (memory)\n    $ sztpd sqlite:///relative/path/to/sztpd.db     (unix)\n    $ sztpd sqlite:////absolute/path/to/sztpd.db    (unix)\n    $ sztpd sqlite:///C:\\path\\to\\sztpd.db           (windows)\n\nFor both the "postgresql" and "mysql+pymysql" dialects, the dialect-specific-path\nfollows the format "//<user>:<passwd>@<host>:<port>/<database-name>".\n\n  Examples:\n\n    The following two examples assume the database is called "sztpd" and\n    that the database server listens on the loopback address with no TLS.\n\n      $ sztpd postgresql://user:pass@localhost:5432/sztpd\n      $ sztpd mysql+pymysql://user:pass@localhost:3306/sztpd\n\n\nPlease see the documentation for more information.\n');A.add_argument('-v','--version',help='show version number and exit.',action='version',version=__version__.__version__);A.add_argument('-d','--debug',help='increase debug output level up to 3x (e.g., -ddd)',action='count',default=0);A.add_argument('-c','--cacert',help='path to trust anchor certificates used to authenticate the database (see below for details).');A.add_argument('-k','--key',help='path to pkcs#12 used to authenticate into the database (see below for details).');A.add_argument('database_url',help='see below for details.',metavar='database-url');B=A.parse_args();return sztpd.run(B.debug,B.database_url,B.cacert)
if __name__=='__main__':sys.exit(main())